## org.jfree.data.general
Class DefaultHeatMapDataset

    java.lang.Object
      org.jfree.data.general.AbstractDataset
          org.jfree.data.general.DefaultHeatMapDataset

All Implemented Interfaces:
  java.io.ObjectInputValidation, java.io.Serializable, java.lang.Cloneable, Dataset, HeatMapDataset, org.jfree.util.PublicCloneable

    public class DefaultHeatMapDataset

extends AbstractDataset
implements HeatMapDataset, java.lang.Cloneable, org.jfree.util.PublicCloneable, java.io.Serializable

A default implementation of the `HeatMapDataset` interface.

Since:
  1.0.13
See Also:
  Serialized Form

Constructor Summary
`DefaultHeatMapDataset(int xSamples, int ySamples, double minX, double maxX, double minY, double maxY)` Creates a new dataset where all the z-values are initially 0.

Method Summary
`java.lang.Object` `clone()` Returns an independent copy of this dataset.
`boolean` `equals(java.lang.Object obj)` Tests this dataset for equality with an arbitrary object.
`double` `getMaximumXValue()` Returns the highest x-value represented in this dataset.
`double` `getMaximumYValue()` Returns the highest y-value represented in this dataset.
`double` `getMinimumXValue()` Returns the lowest x-value represented in this dataset.
`double` `getMinimumYValue()` Returns the lowest y-value represented in this dataset.
`int` `getXSampleCount()` Returns the number of x values across the width of the dataset.
`double` `getXValue(int xIndex)` A convenience method that returns the x-value for the given index.
`int` `getYSampleCount()` Returns the number of y values (or samples) for the dataset.
`double` `getYValue(int yIndex)` A convenience method that returns the y-value for the given index.
`java.lang.Number` `getZ(int xIndex, int yIndex)` Returns the z-value at the specified sample position in the dataset.
`double` `getZValue(int xIndex, int yIndex)` Returns the z-value at the specified sample position in the dataset.
`void` `setZValue(int xIndex, int yIndex, double z)` Updates a z-value in the dataset and sends a `DatasetChangeEvent` to all registered listeners.
`void` `setZValue(int xIndex, int yIndex, double z, boolean notify)` Updates a z-value in the dataset and, if requested, sends a `DatasetChangeEvent` to all registered listeners.

Methods inherited from class org.jfree.data.general.AbstractDataset
`addChangeListener, fireDatasetChanged, getGroup, hasListener, notifyListeners, removeChangeListener, setGroup, validateObject`

Methods inherited from class java.lang.Object
`finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### DefaultHeatMapDataset

    public DefaultHeatMapDataset(int xSamples,
                                 int ySamples,
                                 double minX,
                                 double maxX,
                                 double minY,
                                 double maxY)

  Creates a new dataset where all the z-values are initially 0. This is a fixed size array of z-values.

  Parameters:
    `xSamples` - the number of x-values.
    `ySamples` - the number of y-values
    `minX` - the minimum x-value in the dataset.
    `maxX` - the maximum x-value in the dataset.
    `minY` - the minimum y-value in the dataset.
    `maxY` - the maximum y-value in the dataset.

Method Detail

### getXSampleCount

    public int getXSampleCount()

  Returns the number of x values across the width of the dataset. The values are evenly spaced between `getMinimumXValue()` and `getMaximumXValue()`.

  Specified by:
    `getXSampleCount` in interface `HeatMapDataset`
  Returns:
    The number of x-values (always > 0).

### getYSampleCount

    public int getYSampleCount()

  Returns the number of y values (or samples) for the dataset. The values are evenly spaced between `getMinimumYValue()` and `getMaximumYValue()`.

  Specified by:
    `getYSampleCount` in interface `HeatMapDataset`
  Returns:
    The number of y-values (always > 0).

### getMinimumXValue

    public double getMinimumXValue()

  Returns the lowest x-value represented in this dataset. A requirement of this interface is that this method must never return infinite or Double.NAN values.

  Specified by:
    `getMinimumXValue` in interface `HeatMapDataset`
  Returns:
    The lowest x-value represented in this dataset.

### getMaximumXValue

    public double getMaximumXValue()

  Returns the highest x-value represented in this dataset. A requirement of this interface is that this method must never return infinite or Double.NAN values.

  Specified by:
    `getMaximumXValue` in interface `HeatMapDataset`
  Returns:
    The highest x-value represented in this dataset.

### getMinimumYValue

    public double getMinimumYValue()

  Returns the lowest y-value represented in this dataset. A requirement of this interface is that this method must never return infinite or Double.NAN values.

  Specified by:
    `getMinimumYValue` in interface `HeatMapDataset`
  Returns:
    The lowest y-value represented in this dataset.

### getMaximumYValue

    public double getMaximumYValue()

  Returns the highest y-value represented in this dataset. A requirement of this interface is that this method must never return infinite or Double.NAN values.

  Specified by:
    `getMaximumYValue` in interface `HeatMapDataset`
  Returns:
    The highest y-value represented in this dataset.

### getXValue

    public double getXValue(int xIndex)

  A convenience method that returns the x-value for the given index.

  Specified by:
    `getXValue` in interface `HeatMapDataset`
  Parameters:
    `xIndex` - the xIndex.
  Returns:
    The x-value.

### getYValue

    public double getYValue(int yIndex)

  A convenience method that returns the y-value for the given index.

  Specified by:
    `getYValue` in interface `HeatMapDataset`
  Parameters:
    `yIndex` - the yIndex.
  Returns:
    The y-value.

### getZValue

    public double getZValue(int xIndex,
                            int yIndex)

  Returns the z-value at the specified sample position in the dataset. For a missing or unknown value, this method should return Double.NAN.

  Specified by:
    `getZValue` in interface `HeatMapDataset`
  Parameters:
    `xIndex` - the position of the x sample in the dataset.
    `yIndex` - the position of the y sample in the dataset.
  Returns:
    The z-value.

### getZ

    public java.lang.Number getZ(int xIndex,
                                 int yIndex)

  Returns the z-value at the specified sample position in the dataset. In this implementation, where the underlying values are stored in an array of double primitives, you should avoid using this method and use `getZValue(int, int)` instead.

  Specified by:
    `getZ` in interface `HeatMapDataset`
  Parameters:
    `xIndex` - the position of the x sample in the dataset.
    `yIndex` - the position of the y sample in the dataset.
  Returns:
    The z-value.

### setZValue

    public void setZValue(int xIndex,
                          int yIndex,
                          double z)

  Updates a z-value in the dataset and sends a `DatasetChangeEvent` to all registered listeners.

  Parameters:
    `xIndex` - the x-index.
    `yIndex` - the y-index.
    `z` - the new z-value.

### setZValue

    public void setZValue(int xIndex,
                          int yIndex,
                          double z,
                          boolean notify)

  Updates a z-value in the dataset and, if requested, sends a `DatasetChangeEvent` to all registered listeners.

  Parameters:
    `xIndex` - the x-index.
    `yIndex` - the y-index.
    `z` - the new z-value.
    `notify` - notify listeners?

### equals

    public boolean equals(java.lang.Object obj)

  Tests this dataset for equality with an arbitrary object.

  Overrides:
    `equals` in class `java.lang.Object`
  Parameters:
    `obj` - the object (`null` permitted).
  Returns:
    A boolean.

### clone

    public java.lang.Object clone()
                           throws java.lang.CloneNotSupportedException

  Returns an independent copy of this dataset.

  Specified by:
    `clone` in interface `org.jfree.util.PublicCloneable`
  Overrides:
    `clone` in class `AbstractDataset`
  Returns:
    A clone.
  Throws:
    `java.lang.CloneNotSupportedException`